
Piece = {}

local mydata = require "mydata"

local Base = mydata.Base
local xS = mydata.xS*0.8
local _cellWidth = mydata.HorizontalDistance
local _cellHeight = mydata.VerticalDistance


Piece.newPiece = function(board, kind, new)

    local _numRow = 6

    local Base = mydata.Base

    local _piece = Sprite.new()
        
    local _sprite = Bitmap.new(Base:getTextureRegion(1)) --["gamea5"] = 66
    _sprite:setAnchorPoint(0.5, 0.5)
    _piece.baseSprite = _sprite
    _piece:addChild(_sprite)
    _piece.new = new
    
    _piece.kind = kind
    _piece.board = board
    _piece:setScale(xS, xS)
    


    local f = mydata.colorTable.colorSelected[kind]
    _sprite:setColorTransform(f[1]/255,f[2]/255,f[3]/255)

    if new == true then
        local f = mydata.colorTable.colorSelected[kind+3]
        _sprite:setColorTransform(f[1]/255,f[2]/255,f[3]/255)
    end

                

    -- true if p2 is right below this piece
    function _piece:below(p2, newSlots, newtable, type1)


            local p2x, p2y = newSlots:localToGlobal(p2:getPosition()) 

            if (not self) or (not self:getX()) or (not self:getY()) or (not p2x) or (not p2y) then return false end

            print("still moving")

            if self:getX()>=p2x-0.5*_cellWidth and self:getX()<=p2x+0.5*_cellWidth and 
                self:getY()>=p2y-0.5*_cellHeight and self:getY()<=p2y+0.5*_cellHeight then

                

                return true
            end

    end
                                   

    
    return _piece    
end


return Piece
